/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"

#include "iodefine.h"


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#define Kp 1.0;				//vNR[h12.3

#define r_sen_ref 537	//EZTt@X
#define l_sen_ref 518	//ZTt@X
#define r_wall_ref 40
#define l_wall_ref 27


//O[oϐ
volatile float v,a;
volatile unsigned int step_l,step_r;		//[^̃pX
volatile short r_sen,l_sen,fr_sen,fl_sen;	//EAOZŤݒl
volatile char attitude_control;				//pRg[


//vOR[h8.1
void init_clock(void){
	SYSTEM.PRCR.WORD   = 0xa50b;			//NbN\[XI̕ی̉
	SYSTEM.PLLCR.WORD  = 0x0F00;			// PLL {~16 1 (12.000MHz * 16 = 192MHz)
	SYSTEM.PLLCR2.BYTE = 0x00;				// PLL ENABLE
	SYSTEM.SCKCR.LONG  = 0x21C21211;		//FCK1/4 ICK1/2 BCLK~ SDCLK~ BCK1/4 PCLKA1/2 PCLKB1/4
	SYSTEM.SCKCR2.WORD = 0x0032;			// UCLK1/4 IEBCK1/4
	SYSTEM.BCKCR.BYTE  = 0x01;				// BCLK = 1/2
	SYSTEM.SCKCR3.WORD = 0x0400;			//PLLHI
}

//vOR[h8.2
void CMT0_init(void){ 
	SYSTEM.PRCR.WORD = 0xA502;				//veNg̉
	MSTP(CMT0) = 0;							//CMT0enable
	SYSTEM.PRCR.WORD = 0xA500;
	CMT.CMSTR0.BIT.STR0 = 0;				//CMT0̃JEg~
	CMT0.CMCR.BIT.CKS=1;					//32
	CMT0.CMCR.BIT.CMIE=1;					//荞݋
	CMT0.CMCNT=0;							//JE^[̃NA
	CMT0.CMCOR=375-1;						//0.25ms
	IEN(CMT0,CMI0) = 1;						//荞݋
	IPR(CMT0,CMI0) = 15; 					//荞݂̗D揇
	IR(CMT0,CMI0)=0; 						//
	CMT.CMSTR0.BIT.STR0=1;					//CMT0̃JEgX^[g
}


//vOR[hR[h8.6
void motor_init(void)
{
//I/O̐ݒ
	PORT1.PODR.BIT.B5 = 0;
	PORT1.PDR.BIT.B5 = 1;
	PORTC.PDR.BIT.B5 = 1;
	PORTC.PDR.BIT.B6 = 1;
	MPC.PWPR.BIT.B0WI = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.P17PFS.BIT.PSEL = 1;
	MPC.PE2PFS.BIT.PSEL = 1;
	MPC.PWPR.BYTE = 0x80;
	PORT1.PMR.BIT.B7 = 1;
	PORTE.PMR.BIT.B2 = 1;
//MTU3,4̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	MTU.TSTR.BYTE = 0;
//E[^\pMTUݒ
	MTU3.TCR.BIT.CCLR = 1;
	MTU3.TCR.BIT.TPSC = 2;
	MTU3.TMDR.BIT.MD = 2;
	MTU3.TIORH.BIT.IOA = 2;
	MTU3.TIORH.BIT.IOB = 1;
	MTU3.TGRA = 6297;
	MTU3.TGRB = 50;
	MTU3.TGRC = 6297;
	MTU3.TMDR.BIT.BFA = 1;
	MTU3.TIER.BIT.TGIEB = 1;
	IEN(MTU3,TGIB3) = 1;
	IPR(MTU3,TGIB3) = 13;
	IR(MTU3,TGIB3) = 0;
//[^\pMTUݒ
	MTU.TOER.BIT.OE4A = 1;
	MTU4.TCR.BIT.CCLR = 1;
	MTU4.TCR.BIT.TPSC = 2;
	MTU4.TMDR.BIT.MD = 2;
	MTU4.TIORH.BIT.IOA = 2;
	MTU4.TIORH.BIT.IOB = 1;
	MTU4.TGRA = 6297;
	MTU4.TGRB = 50;
	MTU4.TGRC = 6297;
	MTU4.TMDR.BIT.BFA = 1;
	MTU4.TIER.BIT.TGIEB = 1;
	IEN(MTU4,TGIB4) = 1;
	IPR(MTU4,TGIB4) = 12;
	IR(MTU4,TGIB4) = 0;
	MTU3.TCNT = 0;
	MTU4.TCNT = 0;
}

//vOR[h10.1
void SENSOR_init(void)
{
//I/O̐ݒ
	PORT5.PDR.BIT.B4 = 1;
	PORT0.PDR.BIT.B5 = 1;
	PORT2.PDR.BIT.B7 = 1;
	PORTB.PDR.BIT.B5 = 1;
	PORT5.PODR.BIT.B4 = 0;
	PORT0.PODR.BIT.B5 = 0;
	PORT2.PODR.BIT.B7 = 0;
	PORTB.PODR.BIT.B5 = 0;
	PORTE.PMR.BIT.B1 = 1;
	PORT4.PMR.BIT.B4 = 1;
	PORT4.PMR.BIT.B6 = 1;
	PORT4.PMR.BIT.B2 = 1;
	MPC.PWPR.BIT.B0WI = 0;
	MPC.PWPR.BIT.PFSWE = 1;
	MPC.PE1PFS.BIT.ASEL = 1;
	MPC.P44PFS.BIT.ASEL = 1;
	MPC.P46PFS.BIT.ASEL = 1;
	MPC.P42PFS.BIT.ASEL = 1;
	MPC.PWPR.BYTE = 0x80;
//A/D̐ݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(S12AD) = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	S12AD.ADCSR.BIT.CKS = 3;
	S12AD.ADCSR.BIT.ADCS = 0;
}
	

//vOR[h11.1
void CMT1_init(void){ 
	SYSTEM.PRCR.WORD = 0xA502;			//veNg̉
	MSTP(CMT1) = 0;						//CMT1enable
	SYSTEM.PRCR.WORD = 0xA500;
	CMT.CMSTR0.BIT.STR1 = 0;			//CMT1̃JEg~
	CMT1.CMCR.BIT.CKS=1;				//32
	CMT1.CMCR.BIT.CMIE=1;				//荞݋
	CMT1.CMCNT=0;						//JE^[̃NA
	CMT1.CMCOR=1500-1;					//1ms
	IEN(CMT1,CMI1) = 1;					//荞݋
	IPR(CMT1,CMI1) = 15; 				//荞݂̗D揇
	IR(CMT1,CMI1)=0; 					//
	CMT.CMSTR0.BIT.STR1=1;				//CMT1̃JEgX^[g
}


//vOR[h11.2
void int_mot_r(void)
{
	step_r++;
}

//vOR[h11.2
void int_mot_l(void)
{
	step_l++;
}


//vNR[h12.3
void int_cmt1(void)
{

	short sen_diff;
	float control_motor;

	v = a + v;
	sen_diff = r_sen - l_sen;
	control_motor = (float)sen_diff * Kp;
	MTU3.TGRC = 3000000/( (( v + control_motor) /0.377) );
	MTU4.TGRC = 3000000/( (( v - control_motor) /0.377) );
}

/*
//vNR[h12.4
void int_cmt1(void)
{

	short sen_diff,sen_diff_r,sen_diff_l,scale;
	float control_motor;

	v = a + v;

	scale=1;
	if( (r_wall_ref + r_sen_ref)/2 < r_sen)//E̕ǂ
	{
		sen_diff_r = r_sen - r_sen_ref;
	}else{
		sen_diff_r = 0;
		scale=2;
		
	}
	if( (l_wall_ref + l_sen_ref)/2 < l_sen)//̕ǂ
	{
		sen_diff_l = l_sen_ref - l_sen ;
	}else{
		sen_diff_l = 0;
		scale=2;		
	}

	sen_diff = (sen_diff_l + sen_diff_r) * scale;
	control_motor = (float)sen_diff * Kp;
	MTU3.TGRC = 3000000/( (( v + control_motor) /0.377) );
	MTU4.TGRC = 3000000/( (( v - control_motor) /0.377) );
}
*/


//vOR[h12.2
void int_cmt0(void)
{
	static char state=0;
	short i;

	switch(state)
	{
		case 0:
			PORT0.PODR.BIT.B5 = 1;		//EZTpLEDJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0040;	//AN006(ẼZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORT0.PODR.BIT.B5 = 0;		//EZTpLED	
			r_sen = S12AD.ADDR6;
			break;
		case 1:
			PORT5.PODR.BIT.B4 = 1;		//ZTpLEDsJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0004;	//AN002(̃ZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORT5.PODR.BIT.B4 = 0;		//ZTpLED
			l_sen = S12AD.ADDR2;
			break;
		case 2:
			PORTB.PODR.BIT.B5 = 1;		//EOZTpLEDJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0200;	//AN009(EÕZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORTB.PODR.BIT.B5 = 0;		//EOZTpLED	
			fr_sen = S12AD.ADDR9;
			break;
		case 3:
			PORT2.PODR.BIT.B7 = 1;		//OZTpLEDsJn
			for(i = 0; i < 300; i++);	//gWX^܂ő҂
			S12AD.ADANS0.BIT.ANS0=0x0010;	//AN004(ÕZT)
			S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
			while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
			PORT2.PODR.BIT.B7 = 0;		//OZTpLED
			fl_sen = S12AD.ADDR4;
			break;
	}
	state++;
	if(state > 3) state=0;
}

//vOR[h12.1
void main(void)
{
	init_clock();
	CMT0_init();
	CMT1_init();
	SENSOR_init();
	motor_init();
	
	PORT1.PODR.BIT.B5=1;
	PORTC.PODR.BIT.B5=0;
	PORTC.PODR.BIT.B6=0;
	
	a=0;
	v=180;
	
	MTU.TSTR.BIT.CST3=1;
	MTU.TSTR.BIT.CST4=1;
	
	while(1);
}


#ifdef __cplusplus
void abort(void)
{

}
#endif
